<?php

declare(strict_types=1);

namespace PrestaShop\Module\ConotoxiaPay\Repository;

use Db;

/**
 * Class RefundRepository
 * @package PrestaShop\Module\ConotoxiaPay\Repository
 */
class RefundRepository
{
    /**
     * @param $id_payment
     * @return bool
     * @throws \PrestaShopDatabaseException
     */
    public static function isAnyFullRefund($id_payment)
    {
        $result = Db::getInstance()->executeS('
            SELECT `type` 
            FROM `' . _DB_PREFIX_ . 'conpay_refund` 
            WHERE `id_payment` = \'' . $id_payment . '\'
            GROUP BY `type`'
        );
        if (isset($result[0]['type'])) {
            return $result[0]['type'] === 'FULL';
        }
        return false;
    }

    /**
     * @param string $id_refund
     * @param string $status
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     * @throws \PrestaShopDatabaseException
     */
    public static function updateRefundStatus($id_refund, $status)
    {
        return Db::getInstance()->execute('
            UPDATE `' . _DB_PREFIX_ . 'conpay_refund` 
            SET `status` = \'' . $status . '\'
            WHERE `id_refund` = \'' . $id_refund . '\''
        );
    }

    /**
     * @param int $id_order
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     * @throws \PrestaShopDatabaseException
     */
    public static function getRefundsByOrderId($id_order)
    {
        return Db::getInstance()->executeS('
            SELECT * 
            FROM `' . _DB_PREFIX_ . 'conpay_refund` 
            WHERE `id_order` = ' . $id_order
        );
    }

    /**
     * @param string $id_refund
     * @return bool
     * @throws \PrestaShopDatabaseException
     */
    public static function isRefundPresent($id_refund)
    {
        $result = Db::getInstance()->executeS('
            SELECT count(`id_refund`) as "count"
            FROM `' . _DB_PREFIX_ . 'conpay_refund` 
            WHERE `id_refund` = \'' . $id_refund . '\''
        );
        if (isset($result[0]['count'])) {
            return ((int)$result[0]['count']) > 0;
        }
        return false;
    }

    /**
     * @param int $id_order
     * @param string $id_refund
     * @param float $amount
     * @param int $id_currency
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     * @throws \PrestaShopDatabaseException
     */
    public static function createRefund($id_order, $id_refund, $id_payment, $type, $amount, $id_currency)
    {
        return Db::getInstance()->execute('
            INSERT INTO `' . _DB_PREFIX_ . 'conpay_refund` (
                `date`,
                `amount`,
                `id_currency`,
                `status`,
                `type`,
                `id_payment`,
                `id_refund`,
                `id_order`
            ) VALUES (
                NOW(), 
                ' . $amount . ',
                ' . $id_currency . ',
                \'UNKNOWN\',
                \'' . $type . '\',
                \'' . $id_payment . '\',
                \'' . $id_refund . '\',
                ' . $id_order . '
            )'
        );
    }
}