<?php

use PrestaShop\Module\ConotoxiaPay\Configure\Configurator;

/**
 * @param Module $module
 * @return bool
 */
function upgrade_module_1_23_0($module)
{
    $registerHooks = [
        'paymentOptions',
        'displayAdminOrderTabLink',
        'displayAdminOrderTabContent',
        'actionUpdateLangAfter'
    ];

    $result = true;
    foreach ($registerHooks as $hook) {
        $partialResult = $module->registerHook($hook);
        if (!$partialResult) {
            PrestaShopLogger::addLog('ConotoxiaPay - problem with registering: ' . $hook . ' hook', 3, null, null, null, true);
        }
        $result &= $partialResult;
    }
    return $result;
}